blob: c5f665f4d1cf1f8b3baa96f8e13e131fe2003443 [file] [log] [blame]
Peter Tyserf2352872009-12-06 23:58:28 -06001#!/bin/bash
Wolfgang Denk0777eaf2010-10-17 12:26:48 +02002# Tool mainly for U-Boot Quality Assurance: build one or more board
3# configurations with minimal verbosity, showing only warnings and
4# errors.
Wolfgang Denkeca3aeb2013-06-21 10:22:36 +02005#
6# SPDX-License-Identifier: GPL-2.0+
Wolfgang Denk0777eaf2010-10-17 12:26:48 +02007
Mike Frysingerd8e392d2011-04-21 22:01:43 +00008usage()
9{
10 # if exiting with 0, write to stdout, else write to stderr
11 local ret=${1:-0}
12 [ "${ret}" -eq 1 ] && exec 1>&2
13 cat <<-EOF
14 Usage: MAKEALL [options] [--] [boards-to-build]
15
16 Options:
17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC
Masahiro Yamada4d1584b2013-11-21 19:06:58 +090021 -b BOARD, --board BOARD Build all boards with board name BOARD
Marek Vasut7f79c6f2011-12-02 21:32:03 +000022 -l, --list List all targets to be built
Marek Vasut9b96c6b2012-03-05 15:10:51 +000023 -m, --maintainers List all targets and maintainer email
24 -M, --mails List all targets and all affilated emails
Kim Phillips33f336d2012-09-27 14:57:34 +000025 -C, --check Enable build checking
Joe Hershberger08510202012-10-30 15:55:21 +000026 -n, --continue Continue (skip boards already built)
27 -r, --rebuild-errors Rebuild any boards that errored
Mike Frysingerd8e392d2011-04-21 22:01:43 +000028 -h, --help This help output
29
30 Selections by these options are logically ANDed; if the same option
31 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
32 will select all configurations where the vendor is either FOO or
33 BAR. Any additional arguments specified on the command line are
34 always build additionally. See the boards.cfg file for more info.
35
36 If no boards are specified, then the default is "powerpc".
37
38 Environment variables:
39 BUILD_NCPUS number of parallel make jobs (default: auto)
40 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
Allen Martin47104c32013-01-29 14:34:58 +000041 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
Wolfgang Denk93e14592013-10-04 17:43:24 +020042 architecture "ARCH". Substitute "ARCH" for any
43 supported architecture (default: "")
Mike Frysingerd8e392d2011-04-21 22:01:43 +000044 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
45 BUILD_DIR output build directory (default: ./)
Andy Flemingf588bb02012-04-24 19:33:51 +000046 BUILD_NBUILDS number of parallel targets (default: 1)
Mike Frysingerd8e392d2011-04-21 22:01:43 +000047
48 Examples:
49 - build all Power Architecture boards:
50 MAKEALL -a powerpc
51 MAKEALL --arch powerpc
52 MAKEALL powerpc
53 - build all PowerPC boards manufactured by vendor "esd":
54 MAKEALL -a powerpc -v esd
55 - build all PowerPC boards manufactured either by "keymile" or "siemens":
56 MAKEALL -a powerpc -v keymile -v siemens
57 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58 MAKEALL -c mpc83xx -v freescale 4xx
59 EOF
60 exit ${ret}
61}
62
Masahiro Yamada4d1584b2013-11-21 19:06:58 +090063SHORT_OPTS="ha:c:v:s:b:lmMCnr"
64LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020065
66# Option processing based on util-linux-2.13/getopt-parse.bash
67
Wolfgang Denk071bc922010-10-27 22:48:30 +020068# Note that we use `"$@"' to let each command-line parameter expand to a
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020069# separate word. The quotes around `$@' are essential!
70# We need TEMP as the `eval set --' would nuke the return value of
71# getopt.
72TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
73 -n 'MAKEALL' -- "$@"`
74
Mike Frysingerd8e392d2011-04-21 22:01:43 +000075[ $? != 0 ] && usage 1
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020076
77# Note the quotes around `$TEMP': they are essential!
78eval set -- "$TEMP"
79
80SELECTED=''
Marek Vasut7f79c6f2011-12-02 21:32:03 +000081ONLY_LIST=''
Marek Vasut9b96c6b2012-03-05 15:10:51 +000082PRINT_MAINTS=''
83MAINTAINERS_ONLY=''
Joe Hershberger08510202012-10-30 15:55:21 +000084CONTINUE=''
85REBUILD_ERRORS=''
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020086
87while true ; do
88 case "$1" in
89 -a|--arch)
90 # echo "Option ARCH: argument \`$2'"
91 if [ "$opt_a" ] ; then
92 opt_a="${opt_a%)} || \$2 == \"$2\")"
93 else
94 opt_a="(\$2 == \"$2\")"
95 fi
96 SELECTED='y'
97 shift 2 ;;
98 -c|--cpu)
99 # echo "Option CPU: argument \`$2'"
100 if [ "$opt_c" ] ; then
Allen Martinaa2e2792012-08-31 08:30:06 +0000101 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200102 else
Allen Martinaa2e2792012-08-31 08:30:06 +0000103 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200104 fi
105 SELECTED='y'
106 shift 2 ;;
107 -s|--soc)
108 # echo "Option SoC: argument \`$2'"
109 if [ "$opt_s" ] ; then
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200110 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200111 else
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200112 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200113 fi
114 SELECTED='y'
115 shift 2 ;;
116 -v|--vendor)
117 # echo "Option VENDOR: argument \`$2'"
118 if [ "$opt_v" ] ; then
119 opt_v="${opt_v%)} || \$5 == \"$2\")"
120 else
121 opt_v="(\$5 == \"$2\")"
122 fi
123 SELECTED='y'
124 shift 2 ;;
Masahiro Yamada4d1584b2013-11-21 19:06:58 +0900125 -b|--board)
126 # echo "Option BOARD: argument \`$2'"
127 if [ "$opt_b" ] ; then
128 opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
129 else
130 # We need to check the 7th field too
131 # for boards whose 6th field is "-"
132 opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
133 fi
134 SELECTED='y'
135 shift 2 ;;
Kim Phillips33f336d2012-09-27 14:57:34 +0000136 -C|--check)
137 CHECK='C=1'
138 shift ;;
Joe Hershberger08510202012-10-30 15:55:21 +0000139 -n|--continue)
140 CONTINUE='y'
141 shift ;;
142 -r|--rebuild-errors)
143 REBUILD_ERRORS='y'
144 shift ;;
Marek Vasut7f79c6f2011-12-02 21:32:03 +0000145 -l|--list)
146 ONLY_LIST='y'
147 shift ;;
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000148 -m|--maintainers)
149 ONLY_LIST='y'
150 PRINT_MAINTS='y'
151 MAINTAINERS_ONLY='y'
152 shift ;;
153 -M|--mails)
154 ONLY_LIST='y'
155 PRINT_MAINTS='y'
156 shift ;;
Mike Frysingerd8e392d2011-04-21 22:01:43 +0000157 -h|--help)
158 usage ;;
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200159 --)
160 shift ; break ;;
161 *)
162 echo "Internal error!" >&2 ; exit 1 ;;
163 esac
164done
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900165
166GNU_MAKE=$(scripts/show-gnu-make) || {
167 echo "GNU Make not found" >&2
168 exit 1
169}
170
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200171# echo "Remaining arguments:"
172# for arg do echo '--> '"\`$arg'" ; done
173
Masahiro Yamada94ab8f42014-08-22 14:33:40 +0900174tools/genboardscfg.py || {
175 echo "Failed to generate boards.cfg" >&2
176 exit 1
177}
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900178
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200179FILTER="\$1 !~ /^#/"
180[ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
181[ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
182[ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
183[ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
Masahiro Yamada4d1584b2013-11-21 19:06:58 +0900184[ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200185
186if [ "$SELECTED" ] ; then
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200187 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
Peter Tysercd57b0b2010-10-29 17:59:06 -0500188
189 # Make sure some boards from boards.cfg are actually found
190 if [ -z "$SELECTED" ] ; then
191 echo "Error: No boards selected, invalid arguments"
192 exit 1
193 fi
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200194fi
195
196#########################################################################
197
Peter Tyser40a28f02009-09-21 12:04:32 -0500198# Print statistics when we exit
199trap exit 1 2 3 15
200trap print_stats 0
201
Wolfgang Denk7fa6a2f2008-12-09 00:39:08 +0100202# Determine number of CPU cores if no default was set
203: ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
204
205if [ "$BUILD_NCPUS" -gt 1 ]
206then
Peter Tyser55f786d2009-09-21 12:04:33 -0500207 JOBS="-j $((BUILD_NCPUS + 1))"
Wolfgang Denk7fa6a2f2008-12-09 00:39:08 +0100208else
209 JOBS=""
210fi
211
Marian Balakowiczf9328632006-09-01 19:49:50 +0200212if [ "${MAKEALL_LOGDIR}" ] ; then
213 LOG_DIR=${MAKEALL_LOGDIR}
214else
215 LOG_DIR="LOG"
216fi
Stefan Roese887e2ec2006-09-07 11:51:23 +0200217
Andy Flemingf588bb02012-04-24 19:33:51 +0000218: ${BUILD_NBUILDS:=1}
219BUILD_MANY=0
220
221if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
222 BUILD_MANY=1
223 : ${BUILD_DIR:=./build}
224 mkdir -p "${BUILD_DIR}/ERR"
225 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
Marian Balakowiczf9328632006-09-01 19:49:50 +0200226fi
227
Andy Flemingf588bb02012-04-24 19:33:51 +0000228: ${BUILD_DIR:=.}
229
230OUTPUT_PREFIX="${BUILD_DIR}"
231
232[ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
Joe Hershberger08510202012-10-30 15:55:21 +0000233if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
234 find "${LOG_DIR}/" -type f -exec rm -f {} +
235fi
wdenk7ebf7442002-11-02 23:17:16 +0000236
237LIST=""
238
Peter Tyser40a28f02009-09-21 12:04:32 -0500239# Keep track of the number of builds and errors
240ERR_CNT=0
241ERR_LIST=""
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000242WRN_CNT=0
243WRN_LIST=""
Peter Tyser40a28f02009-09-21 12:04:32 -0500244TOTAL_CNT=0
Joe Hershberger08510202012-10-30 15:55:21 +0000245SKIP_CNT=0
Andy Flemingf588bb02012-04-24 19:33:51 +0000246CURRENT_CNT=0
247OLDEST_IDX=1
Peter Tyserf2352872009-12-06 23:58:28 -0600248RC=0
Peter Tyser40a28f02009-09-21 12:04:32 -0500249
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400250# Helper funcs for parsing boards.cfg
Masahiro Yamada89487942013-10-21 11:11:28 +0900251targets_by_field()
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400252{
Masahiro Yamada8e5a2d42013-10-21 11:11:27 +0900253 field=$1
254 regexp=$2
255
256 awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
257 boards.cfg
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400258}
Masahiro Yamada8e5a2d42013-10-21 11:11:27 +0900259
Masahiro Yamada89487942013-10-21 11:11:28 +0900260targets_by_arch() { targets_by_field 2 "$@" ; }
261targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
262targets_by_soc() { targets_by_field 4 "$@" ; }
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400263
wdenk7ebf7442002-11-02 23:17:16 +0000264#########################################################################
wdenk0db5bca2003-03-31 17:27:09 +0000265## MPC5xx Systems
266#########################################################################
267
Masahiro Yamada89487942013-10-21 11:11:28 +0900268LIST_5xx="$(targets_by_cpu mpc5xx)"
wdenk0db5bca2003-03-31 17:27:09 +0000269
270#########################################################################
wdenk945af8d2003-07-16 21:53:01 +0000271## MPC5xxx Systems
272#########################################################################
273
Masahiro Yamada89487942013-10-21 11:11:28 +0900274LIST_5xxx="$(targets_by_cpu mpc5xxx)"
wdenk945af8d2003-07-16 21:53:01 +0000275
276#########################################################################
Rafal Jaworowski8993e542007-07-27 14:43:59 +0200277## MPC512x Systems
278#########################################################################
279
Masahiro Yamada89487942013-10-21 11:11:28 +0900280LIST_512x="$(targets_by_cpu mpc512x)"
wdenk7ebf7442002-11-02 23:17:16 +0000281
282#########################################################################
283## MPC8xx Systems
284#########################################################################
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400285
Masahiro Yamada89487942013-10-21 11:11:28 +0900286LIST_8xx="$(targets_by_cpu mpc8xx)"
wdenk7ebf7442002-11-02 23:17:16 +0000287
288#########################################################################
289## PPC4xx Systems
290#########################################################################
291
Masahiro Yamada89487942013-10-21 11:11:28 +0900292LIST_4xx="$(targets_by_cpu ppc4xx)"
wdenk7ebf7442002-11-02 23:17:16 +0000293
294#########################################################################
wdenk7aa78612003-05-03 15:50:43 +0000295## MPC8260 Systems (includes 8250, 8255 etc.)
wdenk7ebf7442002-11-02 23:17:16 +0000296#########################################################################
297
Masahiro Yamada89487942013-10-21 11:11:28 +0900298LIST_8260="$(targets_by_cpu mpc8260)"
wdenk7ebf7442002-11-02 23:17:16 +0000299
300#########################################################################
Eran Libertyf046ccd2005-07-28 10:08:46 -0500301## MPC83xx Systems (includes 8349, etc.)
302#########################################################################
303
Masahiro Yamada89487942013-10-21 11:11:28 +0900304LIST_83xx="$(targets_by_cpu mpc83xx)"
Eran Libertyf046ccd2005-07-28 10:08:46 -0500305
306#########################################################################
wdenk42d1f032003-10-15 23:53:47 +0000307## MPC85xx Systems (includes 8540, 8560 etc.)
308#########################################################################
309
Masahiro Yamada89487942013-10-21 11:11:28 +0900310LIST_85xx="$(targets_by_cpu mpc85xx)"
wdenk42d1f032003-10-15 23:53:47 +0000311
312#########################################################################
Jon Loeliger822d5532007-05-23 14:09:46 -0500313## MPC86xx Systems
314#########################################################################
315
Masahiro Yamada89487942013-10-21 11:11:28 +0900316LIST_86xx="$(targets_by_cpu mpc86xx)"
Jon Loeliger822d5532007-05-23 14:09:46 -0500317
318#########################################################################
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700319## PowerPC groups
320#########################################################################
321
322LIST_TSEC=" \
323 ${LIST_83xx} \
324 ${LIST_85xx} \
325 ${LIST_86xx} \
326"
327
Stefan Roesea47a12b2010-04-15 16:07:28 +0200328LIST_powerpc=" \
Kim Phillipsfb565792007-08-10 15:34:48 -0500329 ${LIST_5xx} \
Jean-Christophe PLAGNIOL-VILLARD3deca9d2007-11-25 22:39:25 +0100330 ${LIST_512x} \
Kim Phillipsfb565792007-08-10 15:34:48 -0500331 ${LIST_5xxx} \
332 ${LIST_8xx} \
Kim Phillipsfb565792007-08-10 15:34:48 -0500333 ${LIST_824x} \
334 ${LIST_8260} \
335 ${LIST_83xx} \
336 ${LIST_85xx} \
337 ${LIST_86xx} \
338 ${LIST_4xx} \
Kim Phillipsfb565792007-08-10 15:34:48 -0500339"
wdenk7ebf7442002-11-02 23:17:16 +0000340
Stefan Roesea47a12b2010-04-15 16:07:28 +0200341# Alias "ppc" -> "powerpc" to not break compatibility with older scripts
342# still using "ppc" instead of "powerpc"
343LIST_ppc=" \
344 ${LIST_powerpc} \
345"
346
wdenk7ebf7442002-11-02 23:17:16 +0000347#########################################################################
348## StrongARM Systems
349#########################################################################
350
Masahiro Yamada89487942013-10-21 11:11:28 +0900351LIST_SA="$(targets_by_cpu sa1100)"
wdenk7ebf7442002-11-02 23:17:16 +0000352
353#########################################################################
Allen Martincce5d212012-08-29 11:08:59 +0000354## ARM7 Systems
355#########################################################################
356
Masahiro Yamada89487942013-10-21 11:11:28 +0900357LIST_ARM7="$(targets_by_cpu arm720t)"
Allen Martincce5d212012-08-29 11:08:59 +0000358
359#########################################################################
wdenk7ebf7442002-11-02 23:17:16 +0000360## ARM9 Systems
361#########################################################################
362
Masahiro Yamada89487942013-10-21 11:11:28 +0900363LIST_ARM9="$(targets_by_cpu arm920t) \
364 $(targets_by_cpu arm926ejs) \
365 $(targets_by_cpu arm946es) \
wdenk6f213472003-08-29 22:00:43 +0000366"
wdenk7ebf7442002-11-02 23:17:16 +0000367
368#########################################################################
wdenk8ed96042005-01-09 23:16:25 +0000369## ARM11 Systems
370#########################################################################
Masahiro Yamada89487942013-10-21 11:11:28 +0900371LIST_ARM11="$(targets_by_cpu arm1136) \
372 $(targets_by_cpu arm1176) \
Allen Martincce5d212012-08-29 11:08:59 +0000373"
wdenk8ed96042005-01-09 23:16:25 +0000374
375#########################################################################
Steve Sakomanf56348a2010-06-17 21:50:01 -0700376## ARMV7 Systems
Dirk Behmef904cdb2009-01-27 18:19:12 +0100377#########################################################################
Dirk Behmef37586b2011-08-05 20:48:32 +0000378
Masahiro Yamada89487942013-10-21 11:11:28 +0900379LIST_ARMV7="$(targets_by_cpu armv7)"
Dirk Behmef904cdb2009-01-27 18:19:12 +0100380
381#########################################################################
David Feng2475e632013-12-14 11:47:38 +0800382## ARMV8 Systems
383#########################################################################
384
385LIST_ARMV8="$(targets_by_cpu armv8)"
386
387#########################################################################
Jean-Christophe PLAGNIOL-VILLARD602cac12008-05-24 12:47:46 +0200388## AT91 Systems
389#########################################################################
390
Masahiro Yamada89487942013-10-21 11:11:28 +0900391LIST_at91="$(targets_by_soc at91)"
Jean-Christophe PLAGNIOL-VILLARD602cac12008-05-24 12:47:46 +0200392
393#########################################################################
wdenk7ebf7442002-11-02 23:17:16 +0000394## Xscale Systems
395#########################################################################
396
Masahiro Yamada89487942013-10-21 11:11:28 +0900397LIST_pxa="$(targets_by_cpu pxa)"
wdenk7ebf7442002-11-02 23:17:16 +0000398
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700399#########################################################################
Stefan Roese24dede42012-05-30 22:59:43 +0000400## SPEAr Systems
401#########################################################################
402
Masahiro Yamada89487942013-10-21 11:11:28 +0900403LIST_spear="$(targets_by_soc spear)"
Stefan Roese24dede42012-05-30 22:59:43 +0000404
405#########################################################################
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700406## ARM groups
407#########################################################################
wdenk2d5b5612003-10-14 19:43:55 +0000408
David Feng2475e632013-12-14 11:47:38 +0800409LIST_arm="$(targets_by_arch arm | \
410 for ARMV8_TARGET in $LIST_ARMV8; \
411 do sed "/$ARMV8_TARGET/d"; \
412 done) \
413"
wdenk7ebf7442002-11-02 23:17:16 +0000414
wdenkc0218802003-03-27 12:09:35 +0000415#########################################################################
Wolfgang Denkb62bdff2005-08-14 00:27:00 +0200416## MIPS Systems (default = big endian)
wdenkc0218802003-03-27 12:09:35 +0000417#########################################################################
418
Daniel Schwierzecked638b62014-04-17 21:45:59 +0200419LIST_mips="$(targets_by_arch mips)"
wdenkc0218802003-03-27 12:09:35 +0000420
Stefan Kristianssondeddf5d2011-11-18 19:21:37 +0000421#########################################################################
422## OpenRISC Systems
423#########################################################################
424
Masahiro Yamada89487942013-10-21 11:11:28 +0900425LIST_openrisc="$(targets_by_arch openrisc)"
Wolfgang Denkb62bdff2005-08-14 00:27:00 +0200426
427#########################################################################
Graeme Russfea25722011-04-13 19:43:28 +1000428## x86 Systems
wdenk7a8e9bed2003-05-31 18:35:21 +0000429#########################################################################
430
Masahiro Yamada89487942013-10-21 11:11:28 +0900431LIST_x86="$(targets_by_arch x86)"
wdenk7a8e9bed2003-05-31 18:35:21 +0000432
wdenkc935d3b2004-01-03 19:43:48 +0000433#########################################################################
wdenk5c952cf2004-10-10 21:27:30 +0000434## Nios-II Systems
435#########################################################################
436
Masahiro Yamada89487942013-10-21 11:11:28 +0900437LIST_nios2="$(targets_by_arch nios2)"
wdenk5c952cf2004-10-10 21:27:30 +0000438
439#########################################################################
wdenk857cad32004-07-10 23:48:41 +0000440## MicroBlaze Systems
441#########################################################################
442
Masahiro Yamada89487942013-10-21 11:11:28 +0900443LIST_microblaze="$(targets_by_arch microblaze)"
wdenk857cad32004-07-10 23:48:41 +0000444
Zachary P. Landauf8c3b4f2006-01-26 17:38:46 -0500445#########################################################################
446## ColdFire Systems
447#########################################################################
448
Masahiro Yamada89487942013-10-21 11:11:28 +0900449LIST_m68k="$(targets_by_arch m68k)"
Mike Frysingerc13f47b2011-09-25 19:27:19 +0000450LIST_coldfire=${LIST_m68k}
Zachary P. Landauf8c3b4f2006-01-26 17:38:46 -0500451
Wolfgang Denk6ccec442006-10-24 14:42:37 +0200452#########################################################################
453## AVR32 Systems
454#########################################################################
455
Masahiro Yamada89487942013-10-21 11:11:28 +0900456LIST_avr32="$(targets_by_arch avr32)"
Wolfgang Denk6ccec442006-10-24 14:42:37 +0200457
Aubrey.Lief26a082007-03-09 13:40:56 +0800458#########################################################################
459## Blackfin Systems
460#########################################################################
461
Masahiro Yamada89487942013-10-21 11:11:28 +0900462LIST_blackfin="$(targets_by_arch blackfin)"
Aubrey.Lief26a082007-03-09 13:40:56 +0800463
Jean-Christophe PLAGNIOL-VILLARDc7144372007-11-27 09:44:53 +0100464#########################################################################
465## SH Systems
466#########################################################################
467
Masahiro Yamada89487942013-10-21 11:11:28 +0900468LIST_sh2="$(targets_by_cpu sh2)"
469LIST_sh3="$(targets_by_cpu sh3)"
470LIST_sh4="$(targets_by_cpu sh4)"
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700471
Masahiro Yamada89487942013-10-21 11:11:28 +0900472LIST_sh="$(targets_by_arch sh)"
Jean-Christophe PLAGNIOL-VILLARDc7144372007-11-27 09:44:53 +0100473
Daniel Hellstromc2f02da2008-03-28 09:47:00 +0100474#########################################################################
475## SPARC Systems
476#########################################################################
477
Masahiro Yamada89487942013-10-21 11:11:28 +0900478LIST_sparc="$(targets_by_arch sparc)"
wdenk7ebf7442002-11-02 23:17:16 +0000479
Macpaul Lin5f1719c2011-10-19 20:41:10 +0000480#########################################################################
481## NDS32 Systems
482#########################################################################
483
Masahiro Yamada89487942013-10-21 11:11:28 +0900484LIST_nds32="$(targets_by_arch nds32)"
Macpaul Lin5f1719c2011-10-19 20:41:10 +0000485
Alexey Brodkin568c1fa2014-02-04 12:56:20 +0400486#########################################################################
487## ARC Systems
488#########################################################################
489
490LIST_arc="$(targets_by_arch arc)"
491
wdenk7ebf7442002-11-02 23:17:16 +0000492#-----------------------------------------------------------------------
493
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000494get_target_location() {
495 local target=$1
496 local BOARD_NAME=""
497 local CONFIG_NAME=""
498 local board=""
499 local vendor=""
500
501 # Automatic mode
Masahiro Yamada23d64102013-10-21 11:11:25 +0900502 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000503 if [ -z "${line}" ] ; then echo "" ; return ; fi
504
505 set ${line}
506
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900507 CONFIG_NAME="${7%_defconfig}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000508
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900509 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000510
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200511 if [ $# -gt 5 ]; then
512 if [ "$6" = "-" ] ; then
513 board=${BOARD_NAME}
514 else
515 board="$6"
516 fi
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000517 fi
518
519 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200520 [ $# -gt 6 ] && [ "$8" != "-" ] && {
521 tmp="${8%:*}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000522 if [ "$tmp" ] ; then
523 CONFIG_NAME="$tmp"
524 fi
525 }
526
527 # Assign board directory to BOARDIR variable
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200528 if [ "${vendor}" == "-" ] ; then
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000529 BOARDDIR=${board}
530 else
531 BOARDDIR=${vendor}/${board}
532 fi
533
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200534 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000535}
536
537get_target_maintainers() {
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200538 local name=`echo $1 | cut -d : -f 3`
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000539
Masahiro Yamada23d64102013-10-21 11:11:25 +0900540 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200541 if [ -z "${line}" ]; then
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000542 echo ""
543 return ;
544 fi
545
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200546 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
547 [ "$mails" == "-" ] && mails=""
548 echo "$mails"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000549}
550
Allen Martin47104c32013-01-29 14:34:58 +0000551get_target_arch() {
552 local target=$1
553
554 # Automatic mode
Masahiro Yamada54d1f502013-10-21 11:11:26 +0900555 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
Allen Martin47104c32013-01-29 14:34:58 +0000556
557 if [ -z "${line}" ] ; then echo "" ; return ; fi
558
559 set ${line}
560 echo "$2"
561}
562
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000563list_target() {
564 if [ "$PRINT_MAINTS" != 'y' ] ; then
565 echo "$1"
566 return
567 fi
568
569 echo -n "$1:"
570
571 local loc=`get_target_location $1`
572
573 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
574
575 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
576
577 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
578
579 local dir=`echo ${loc} | cut -d ":" -f 2`
580 local cfg=`echo ${loc} | cut -d ":" -f 1`
581 local git_result=`git log --format=%aE board/${dir} \
582 include/configs/${cfg}.h | grep "@"`
583 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
584 head -n 3`
585 local git_result_top=`echo ${git_result} | tr " " "\n" | \
586 sort | uniq -c | sort -nr | head -n 3 | \
587 sed "s/^ \+[0-9]\+ \+//"`
588
589 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
590 sort -u | tr "\n" " " | sed "s/ $//" ;
591 else
592 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
593 sed "s/ $//" ;
594 fi
595
596 echo ""
597}
598
Andy Flemingf588bb02012-04-24 19:33:51 +0000599# Each finished build will have a file called ${donep}${n},
600# where n is the index of the build. Each build
601# we've already noted as finished will have ${skipp}${n}.
602# The code managing the build process will use this information
603# to ensure that only BUILD_NBUILDS builds are in flight at once
604donep="${LOG_DIR}/._done_"
605skipp="${LOG_DIR}/._skip_"
606
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000607build_target_killed() {
608 echo "Aborted $target build."
609 # Remove the logs for this board since it was aborted
610 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
611 exit
612}
613
wdenk7ebf7442002-11-02 23:17:16 +0000614build_target() {
615 target=$1
Andy Flemingf588bb02012-04-24 19:33:51 +0000616 build_idx=$2
617
Andy Flemingf50bf502012-05-09 20:36:28 +0000618 if [ "$ONLY_LIST" == 'y' ] ; then
619 list_target ${target}
620 return
621 fi
622
Andy Flemingf588bb02012-04-24 19:33:51 +0000623 if [ $BUILD_MANY == 1 ] ; then
624 output_dir="${OUTPUT_PREFIX}/${target}"
625 mkdir -p "${output_dir}"
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000626 trap build_target_killed TERM
Andy Flemingf588bb02012-04-24 19:33:51 +0000627 else
628 output_dir="${OUTPUT_PREFIX}"
629 fi
630
Allen Martin47104c32013-01-29 14:34:58 +0000631 target_arch=$(get_target_arch ${target})
York Sunc17b94e2013-03-22 07:37:03 +0000632 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
Allen Martin47104c32013-01-29 14:34:58 +0000633 if [ "${cross_toolchain}" ] ; then
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900634 MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
Allen Martin47104c32013-01-29 14:34:58 +0000635 elif [ "${CROSS_COMPILE}" ] ; then
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900636 MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
Allen Martin47104c32013-01-29 14:34:58 +0000637 else
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900638 MAKE=$GNU_MAKE
Allen Martin47104c32013-01-29 14:34:58 +0000639 fi
640
Masahiro Yamada9e414032014-02-04 17:24:24 +0900641 if [ "${output_dir}" != "." ] ; then
642 MAKE="${MAKE} O=${output_dir}"
643 fi
644
Roger Meierfd18a892014-08-20 22:10:29 +0200645 ${MAKE} mrproper >/dev/null
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900646
647 echo "Building ${target} board..."
648 ${MAKE} -s ${target}_defconfig >/dev/null
Marian Balakowiczf9328632006-09-01 19:49:50 +0200649
Kim Phillips33f336d2012-09-27 14:57:34 +0000650 ${MAKE} ${JOBS} ${CHECK} all \
Andy Flemingf588bb02012-04-24 19:33:51 +0000651 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
Peter Tyserf2352872009-12-06 23:58:28 -0600652
653 # Check for 'make' errors
654 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
655 RC=1
656 fi
657
Andy Flemingf588bb02012-04-24 19:33:51 +0000658 if [ $BUILD_MANY == 1 ] ; then
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000659 trap - TERM
660
Masahiro Yamada73906432014-02-04 17:24:34 +0900661 ${MAKE} -s clean
Andy Flemingf588bb02012-04-24 19:33:51 +0000662
663 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000664 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
Andy Flemingf588bb02012-04-24 19:33:51 +0000665 else
666 rm ${LOG_DIR}/${target}.ERR
667 fi
Peter Tyser40a28f02009-09-21 12:04:32 -0500668 else
Andy Flemingf588bb02012-04-24 19:33:51 +0000669 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000670 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
671 : $(( ERR_CNT += 1 ))
672 ERR_LIST="${ERR_LIST} $target"
673 else
674 : $(( WRN_CNT += 1 ))
675 WRN_LIST="${WRN_LIST} $target"
676 fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000677 else
678 rm ${LOG_DIR}/${target}.ERR
679 fi
Peter Tyser40a28f02009-09-21 12:04:32 -0500680 fi
681
Andy Flemingf588bb02012-04-24 19:33:51 +0000682 OBJS=${output_dir}/u-boot
683 if [ -e ${output_dir}/spl/u-boot-spl ]; then
684 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
Scott Wood0c185692012-02-20 12:56:25 +0000685 fi
686
687 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
Andy Flemingf588bb02012-04-24 19:33:51 +0000688
689 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
690
Andy Flemingf588bb02012-04-24 19:33:51 +0000691 touch "${donep}${build_idx}"
wdenk7ebf7442002-11-02 23:17:16 +0000692}
Andy Flemingf588bb02012-04-24 19:33:51 +0000693
694manage_builds() {
695 search_idx=${OLDEST_IDX}
Andy Flemingf50bf502012-05-09 20:36:28 +0000696 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
697
Andy Flemingf588bb02012-04-24 19:33:51 +0000698 while true; do
699 if [ -e "${donep}${search_idx}" ] ; then
Andy Flemingf588bb02012-04-24 19:33:51 +0000700 : $(( CURRENT_CNT-- ))
701 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
702 : $(( OLDEST_IDX++ ))
703
704 # Only want to count it once
705 rm -f "${donep}${search_idx}"
706 touch "${skipp}${search_idx}"
707 elif [ -e "${skipp}${search_idx}" ] ; then
708 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
709 : $(( OLDEST_IDX++ ))
710 fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000711 : $(( search_idx++ ))
712 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
Andy Flemingf588bb02012-04-24 19:33:51 +0000713 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
714 search_idx=${OLDEST_IDX}
715 sleep 1
716 else
717 break
718 fi
719 fi
720 done
721}
722
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400723build_targets() {
724 for t in "$@" ; do
725 # If a LIST_xxx var exists, use it. But avoid variable
726 # expansion in the eval when a board name contains certain
727 # characters that the shell interprets.
728 case ${t} in
729 *[-+=]*) list= ;;
730 *) list=$(eval echo '${LIST_'$t'}') ;;
731 esac
732 if [ -n "${list}" ] ; then
733 build_targets ${list}
734 else
Andy Flemingf588bb02012-04-24 19:33:51 +0000735 : $((TOTAL_CNT += 1))
736 : $((CURRENT_CNT += 1))
737 rm -f "${donep}${TOTAL_CNT}"
738 rm -f "${skipp}${TOTAL_CNT}"
Joe Hershberger08510202012-10-30 15:55:21 +0000739 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
740 : $((SKIP_CNT += 1))
741 touch "${donep}${TOTAL_CNT}"
742 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
743 : $((SKIP_CNT += 1))
744 touch "${donep}${TOTAL_CNT}"
Joe Hershbergerb594bd62012-05-21 04:49:37 +0000745 else
Joe Hershberger08510202012-10-30 15:55:21 +0000746 if [ $BUILD_MANY == 1 ] ; then
747 build_target ${t} ${TOTAL_CNT} &
748 else
749 CUR_TGT="${t}"
750 build_target ${t} ${TOTAL_CNT}
751 CUR_TGT=''
752 fi
Joe Hershbergerb594bd62012-05-21 04:49:37 +0000753 fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000754 fi
755
756 # We maintain a running count of all the builds we have done.
757 # Each finished build will have a file called ${donep}${n},
758 # where n is the index of the build. Each build
759 # we've already noted as finished will have ${skipp}${n}.
760 # We track the current index via TOTAL_CNT, and the oldest
761 # index. When we exceed the maximum number of parallel builds,
762 # We look from oldest to current for builds that have completed,
763 # and update the current count and oldest index as appropriate.
764 # If we've gone through the entire list, wait a second, and
765 # reprocess the entire list until we find a build that has
766 # completed
767 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
768 manage_builds
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400769 fi
770 done
771}
wdenk7ebf7442002-11-02 23:17:16 +0000772
773#-----------------------------------------------------------------------
774
Andy Flemingf50bf502012-05-09 20:36:28 +0000775kill_children() {
Andreas Bießmann6bdd9f82013-02-07 22:35:57 +0000776 local OS=$(uname -s)
777 local children=""
778 case "${OS}" in
779 "Darwin")
780 # Mac OS X is known to have BSD style ps
781 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
782 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
783 ;;
784 *)
785 # everything else tries the GNU style
786 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
787 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
788 ;;
789 esac
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000790
791 kill $children 2> /dev/null
792 wait $children 2> /dev/null
Andy Flemingf50bf502012-05-09 20:36:28 +0000793
794 exit
795}
796
Peter Tyser40a28f02009-09-21 12:04:32 -0500797print_stats() {
Marek Vasut7f79c6f2011-12-02 21:32:03 +0000798 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000799
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000800 # Only count boards that completed
801 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
802
Andy Flemingf588bb02012-04-24 19:33:51 +0000803 rm -f ${donep}* ${skipp}*
804
805 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
Andy Fleming033220e2012-08-08 14:12:30 +0000806 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000807 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
808 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
Andy Fleming033220e2012-08-08 14:12:30 +0000809 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000810 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
811 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000812 else
813 # Remove the logs for any board that was interrupted
814 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
Andy Flemingf588bb02012-04-24 19:33:51 +0000815 fi
816
Joe Hershberger08510202012-10-30 15:55:21 +0000817 : $((TOTAL_CNT -= ${SKIP_CNT}))
Peter Tyser40a28f02009-09-21 12:04:32 -0500818 echo ""
819 echo "--------------------- SUMMARY ----------------------------"
Joe Hershberger08510202012-10-30 15:55:21 +0000820 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
821 echo "Boards skipped: ${SKIP_CNT}"
822 fi
Peter Tyser40a28f02009-09-21 12:04:32 -0500823 echo "Boards compiled: ${TOTAL_CNT}"
824 if [ ${ERR_CNT} -gt 0 ] ; then
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000825 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
826 fi
827 if [ ${WRN_CNT} -gt 0 ] ; then
828 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
Peter Tyser40a28f02009-09-21 12:04:32 -0500829 fi
830 echo "----------------------------------------------------------"
Peter Tyserf2352872009-12-06 23:58:28 -0600831
Andy Flemingf50bf502012-05-09 20:36:28 +0000832 if [ $BUILD_MANY == 1 ] ; then
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000833 kill_children
Andy Flemingf50bf502012-05-09 20:36:28 +0000834 fi
835
Peter Tyserf2352872009-12-06 23:58:28 -0600836 exit $RC
Peter Tyser40a28f02009-09-21 12:04:32 -0500837}
wdenk7ebf7442002-11-02 23:17:16 +0000838
Peter Tyser40a28f02009-09-21 12:04:32 -0500839#-----------------------------------------------------------------------
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400840
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200841# Build target groups selected by options, plus any command line args
842set -- ${SELECTED} "$@"
843# run PowerPC by default
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400844[ $# = 0 ] && set -- powerpc
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400845build_targets "$@"
Andy Flemingf588bb02012-04-24 19:33:51 +0000846wait